package org.xbib.interlibrary.http.server.avail;

import java.io.IOException;
import java.util.Objects;

import org.xbib.net.ParameterException;
import org.xbib.net.Resource;
import org.xbib.net.http.j2html.J2HtmlResource;
import org.xbib.net.http.j2html.J2HtmlResourceHandler;
import org.xbib.net.http.server.HttpRequest;
import org.xbib.net.http.server.resource.HtmlTemplateResourceHandler;
import org.xbib.net.http.server.route.HttpRouterContext;

public class AvailFormAction extends J2HtmlResourceHandler {

    public AvailFormAction() {
    }

    @Override
    protected Resource createResource(HttpRouterContext httpRouterContext)
            throws IOException, ParameterException {
        return new ActionResource(this, httpRouterContext);
    }

    protected static class ActionResource extends J2HtmlResource {

        protected ActionResource(HtmlTemplateResourceHandler templateResourceHandler,
                                 HttpRouterContext httpRouterContext)
                throws IOException, ParameterException {
            super(templateResourceHandler, httpRouterContext);
        }

        @Override
        protected String renderHtml(HttpRouterContext context) {
            HttpRequest request = context.getAttributes().get(HttpRequest.class, "request");
            Objects.requireNonNull(request);
            AvailApplicationModule app = context.getAttributes().get(AvailApplicationModule.class, "app");
            Objects.requireNonNull(app);
            String id = app.getFormId("availform", request);
            if (id != null) {
                app.executeAvail("availform", request.getContext());
                seeOther(contextPath(request, "form/" + id));
            } else {
                gone();
            }
            return ""; // no content
        }
    }
}
