package org.xbib.interlibrary.http.server.avail;

import org.xbib.net.ParameterException;
import org.xbib.net.Resource;
import org.xbib.net.http.j2html.J2HtmlResource;
import org.xbib.net.http.j2html.J2HtmlResourceHandler;
import org.xbib.net.http.server.resource.HtmlTemplateResourceHandler;
import org.xbib.net.http.server.route.HttpRouterContext;

import java.io.IOException;

public class AvailFormViewHandler extends J2HtmlResourceHandler {

    public AvailFormViewHandler() {
    }

    @Override
    protected Resource createResource(HttpRouterContext httpRouterContext)
            throws IOException, ParameterException {
        return new AvailFormViewResource(this, httpRouterContext);
    }

    protected static class AvailFormViewResource extends J2HtmlResource {

        protected AvailFormViewResource(HtmlTemplateResourceHandler templateResourceHandler,
                                        HttpRouterContext httpRouterContext)
                throws IOException, ParameterException {
            super(templateResourceHandler, httpRouterContext);
        }

        public void render(HttpRouterContext context) throws IOException {
            super.render(context);
            // finish
            context.done();
        }

        @Override
        protected String renderHtml(HttpRouterContext context) throws ParameterException {
            AvailFormView view = new AvailFormView(this, application, request);
            return view.createSimplePage(context, "Verfügbarkeitsrecherche");
        }
    }
}
